#include <cu/clos.h>
#include <assert.h>

struct my_clos_s
{
    cu_clos_base (my_clos_s, int cu_proto(int, double));
    int i;
    int j;
};

static int
my_clos_f(cu_clos_formal(my_clos_s, int k, double x))
{
    cu_clos_arg_dcln(my_clos_s, carg);
    assert(carg->i == 1001);
    assert(carg->j == 1002);
    assert(k == 1003);
    assert(x == 1.1);
    return 1004;
}

static int
my_nonclos_f(int k, double x)
{
    assert(k == 1010);
    assert(x == 1.2);
    return 1011;
}

cu_clos_def(testfn0,
	    int cu_proto(int i, int j),
	    (int k; int l;))
{
    cu_clos_self(testfn0);
    return i*self->k + j*self->l;
}

cu_clos_decl(testfn1,
		int cu_proto(char *s),
		(int n;));

cu_clos_define(testfn1,
		int cu_proto(char *s))
{
    cu_clos_self(testfn1);
    return atoi(s) + self->n;
}


int
main()
{
    int l;
    struct my_clos_s clos;
    int cu_nonclos(plain)(int, double);
    testfn0_t fn0;
    testfn1_t fn1;

    cu_clos_cct(&clos, my_clos_f);
    clos.i = 1001;
    clos.j = 1002;
    l = cu_call(cu_clos_ref(&clos), 1003, 1.1);
    assert(l == 1004);

    cu_nonclos_cct(&plain, my_nonclos_f);
    l = cu_call(cu_nonclos_ref(&plain), 1010, 1.2);
    assert(l == 1011);

    cu_clos_cct(&fn0, testfn0);
    fn0.k = 10;
    fn0.l = 100;
    assert(cu_call(cu_clos_ref(&fn0), 2, 3) == 320);

    cu_clos_cct(&fn1, testfn1);
    fn1.n = 6;
    assert(cu_call(cu_clos_ref(&fn1), "4") == 10);

    return 0;
}
