#include <cucon/fwd.h>
#include <cucon/hset.h>
#include <stdlib.h>
#include <assert.h>

cu_bool_t
eq(void *p0, void *p1)
{
    return p0 == p1;
}

cu_hash_t
hash(void *p)
{
    return (cu_hash_t)p >> 1;
}

int
main()
{
    cu_bool_t cu_nonclos(eq_cb)(void *, void *);
    cu_hash_t cu_nonclos(hash_cb)(void *);
    size_t const n_ins = 100000;
    size_t i;
    cucon_hset_t hs;
    cu_init();

    cu_nonclos_cct(&eq_cb, eq);
    cu_nonclos_cct(&hash_cb, hash);
    hs = cucon_hset_new(cu_nonclos_ref(&eq_cb), cu_nonclos_ref(&hash_cb));
    for (i = 0; i < n_ins; ++i)
	if (cucon_hset_insert(hs, (void*)i) != NULL)
	    assert(!"unexpected degeneracy");
    for (i = 0; i < n_ins; i += 2)
	if (cucon_hset_erase(hs, (void*)i) != (void*)i)
	    assert(!"lost value");
    for (i = 0; i < n_ins; ++i) {
	void *key = cucon_hset_find(hs, (void*)i);
	if (i % 2)
	    assert(key == (void*)i);
	else
	    assert(key == NULL);
    }
    return 0;
}
