#include <cucon/priq.h>
#include <cu/memory.h>
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

cu_bool_fast_t
int_less(void *i0, void *i1)
{
    return *(int*)i0 < *(int*)i1;
}

void
int_print(void *i0, FILE* out)
{
    fprintf(out, "%d", *(int*)i0);
}

int
main()
{
    cu_bool_t cu_nonclos(prior)(void *, void *);
    void cu_nonclos(print)(void *, FILE *);
    int i;
    cucon_priq_t q;

    cu_init();

    cu_nonclos_cct(&prior, int_less);
    cu_nonclos_cct(&print, int_print);
    q = cucon_priq_new(cu_nonclos_ref(&prior));

    printf("Inserting:");
    for (i = 0; i < 40; ++i) {
	int *k = cu_gnew(int);
	*k = lrand48() % 50;
	printf(" %d", *k);
	cucon_priq_insert(q, k);
    }
    printf("\n");
    cucon_priq_dump(q, cu_nonclos_ref(&print), stdout);
    printf("\nPopping:");
    int l = 0;
    for (i = 0; i < 40; ++i) {
	int *k = cucon_priq_pop_front(q);
	assert(*k >= l);
	printf(" %d", *k);
	l = *k;
    }
    printf("\n");
    for (i = 0; i < 4000; ++i) {
	int j;
	int n = lrand48() % 200;
	for (j = 0; j < n; ++j) {
	    int *k = cu_gnew(int);
	    *k = lrand48() % 100;
	    cucon_priq_insert(q, k);
	}
	n = lrand48() % 200;
	int l = 0;
	for (j = 0; j < n; ++j) {
	    int *k = cucon_priq_pop_front(q);
	    if (k == NULL)
		break;
	    assert(*k >= l);
	    l = *k;
	}
    }

    return 0;
}
